#ifndef MYOPENGL_H
#define MYOPENGL_H

#include <QGLWidget>
#include <QLinkedList>

typedef QPoint MyPoint;
typedef struct { MyPoint point; QPointF normal; } MyOrientedPoint;
typedef QLine MyLine;
typedef QLinkedList<MyOrientedPoint> MyPolygon;
typedef struct { MyPoint p1, p2, p3; } MyTriangle;

class MyOpenGL : public QGLWidget
{
Q_OBJECT

public:
	MyOpenGL();

protected:
	void initializeGL();
	void resizeGL(int, int);
	void paintGL();

	void mousePressEvent(QMouseEvent *);
	void mouseReleaseEvent(QMouseEvent *);
	void mouseMoveEvent(QMouseEvent *);

private:
	void addToPolyClip(const MyPoint &);

	int chop(float *, float *, float, float);
	int clipLine(const MyLine &, QLineF *);
	void drawClipLine(const MyLine &);

	void fillTriangle(const MyPoint *, const MyPoint *, const MyPoint *);

	QList<MyLine> lines;
	MyPolygon polyClip;

	QList<MyTriangle> triangles;
};

#endif // MYOPENGL_H
